diff -urNb aodv-uu-0.7.2/Makefile maodv-umd-0.7.2/Makefile
--- aodv-uu-0.7.2/Makefile	Mon Jun  2 19:46:08 2003
+++ maodv-umd-0.7.2/Makefile	Fri Dec  5 17:43:09 2003
@@ -4,7 +4,10 @@
 SRC =	main.c list.c debug.c timer_queue.c aodv_socket.c aodv_hello.c \
 	aodv_neighbor.c aodv_timeout.c routing_table.c seek_list.c \
 	k_route.c aodv_rreq.c aodv_rrep.c aodv_rerr.c packet_input.c \
-	packet_queue.c libipq.c icmp.c
+	packet_queue.c libipq.c icmp.c maodv_grph.c maodv_mact.c \
+	multicast_routing_table.c igmp.c \
+	maodv_rreq.c maodv_rrep.c k_mroute.c multicast_packet_cache.c \
+	maodv_neighbor.c
 
 SRC_NS = 	debug.c list.c timer_queue.c aodv_socket.c aodv_hello.c \
 		aodv_neighbor.c aodv_timeout.c routing_table.c seek_list.c \
@@ -33,7 +36,8 @@
 # Comment out to disable debug operation...
 DEBUG=-g -DDEBUG
 
-DEFS=#-DUSE_IW_SPY
+DEFS= -DMAODV #-DUSE_IW_SPY
+
 CFLAGS=$(OPTS) $(DEBUG) $(DEFS)
 
 ifneq (,$(findstring USE_IW_SPY,$(DEFS)))
@@ -63,13 +67,14 @@
 # These are the options for the kernel modules:
 #==============================================
 KINC=-nostdinc $(shell $(CC) -print-search-dirs | sed -ne 's/install: \(.*\)/-I \1include/gp') -I/lib/modules/$(KERNEL)/build/include
-KDEFS=-D__KERNEL__ -DMODULE
+KDEFS=-D__KERNEL__ -DMODULE -DMAODV
 KCFLAGS=-Wall -O2 $(KDEFS) $(KINC)
 KCFLAGS_ARM =-Wall -O2 -D__KERNEL__ -DMODULE $(KINC)
 
-.PHONY: default clean install uninstall depend tags aodvd-arm docs
+# .PHONY used to have a docs target in it, I removed it, we got no docs...
+.PHONY: default clean install uninstall depend tags aodvd-arm
 
-default: aodvd kaodv.o
+default: aodvd kaodv.o kinject.o
 
 all: default
 
@@ -106,6 +111,10 @@
 kaodv.o: kaodv.c
 	$(CC) $(KCFLAGS) -c -o $@ $<
 
+# Kernel module for packet injection:
+kinject.o: kinject.c
+	$(CC) $(KCFLAGS) -c -o $@ $<
+
 kaodv-arm.o: kaodv.c
 	$(ARM_CC) $(KCFLAGS_ARM) -c -o $(@:%-arm.o=%.o) $<
 tags:
@@ -117,6 +126,7 @@
 	@echo "Updating Makefile dependencies..."
 	@makedepend -Y./ -- $(DEFS) -- $(SRC) &>/dev/null
 	@makedepend -a -Y./ -- $(KDEFS) kaodv.c &>/dev/null
+	@makedepend -a -Y./ -- $(KDEFS) kinject.c &>/dev/null
 
 install: all
 	install -s -m 755 aodvd /usr/sbin/aodvd
@@ -124,14 +134,16 @@
 		mkdir /lib/modules/$(KERNEL)/aodv; \
 	fi
 	install -m 644 kaodv.o /lib/modules/$(KERNEL)/aodv/kaodv.o
+	install -m 644 kinject.o /lib/modules/$(KERNEL)/aodv/kinject.o
 
 	/sbin/depmod -a
 uninstall:
 	rm -f /usr/sbin/aodvd
 	rm -rf /lib/modules/$(KERNEL)/aodv
 
-docs:
-	cd docs && $(MAKE) all
+# Commented out, we don't have any documentation... yet.
+#docs:
+#	cd docs && $(MAKE) all
 clean: 
 	rm -f aodvd *~ *.o core *.log libaodv-uu.a endian endian.h
 #cd docs && $(MAKE) clean
diff -urNb aodv-uu-0.7.2/TODO.maodv maodv-umd-0.7.2/TODO.maodv
--- aodv-uu-0.7.2/TODO.maodv	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/TODO.maodv	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,20 @@
+MAODV TODO
+? expire unactivated nexthops
+* out of spec. umd additions
+  * mact-ack
+  * tree optimization
+* ns-2 maybe...
+* more tests...
+
+MAODV KNOWN LIMITATIONS
+* one way link breaks
+* cannot handle multiple interfaces (although the protocol is
+  at least ill-definied when multiple interfaces are used)
+
+CONCERNS AODV-UU
+* ratelimiting seems broken.
+* setting the d flag for RREQ breaks things.  Incorrect destination 
+  reply code.
+
+DRAW STUFF
+* draw-all needs per-group timeouts
diff -urNb aodv-uu-0.7.2/aodv_hello.c maodv-umd-0.7.2/aodv_hello.c
--- aodv-uu-0.7.2/aodv_hello.c	Mon May 26 16:45:49 2003
+++ maodv-umd-0.7.2/aodv_hello.c	Wed Jun 25 17:46:09 2003
@@ -106,14 +106,15 @@
 	for (i = 0; i < MAX_NR_INTERFACES; i++) {
 	    if (!DEV_NR(i).enabled)
 		continue;
-#ifdef DEBUG_HELLO
+/* #ifdef DEBUG_HELLO */
 	    DEBUG(LOG_DEBUG, 0, "sending Hello to %s",
 		  ip_to_str(AODV_BROADCAST));
-#endif
+/* #endif */
 	    rrep = rrep_create(flags, 0, 0, DEV_NR(i).ipaddr,
 			       this_host.seqno,
 			       DEV_NR(i).ipaddr,
-			       ALLOWED_HELLO_LOSS * HELLO_INTERVAL);
+			       ALLOWED_HELLO_LOSS * HELLO_INTERVAL,
+                               0 );
 
 	    /* Assemble a RREP extension which contain our neighbor set... */
 	    if (unidir_hack) {
@@ -167,7 +168,6 @@
     }
 }
 
-
 /* Process a hello message */
 void NS_CLASS hello_process(RREP * hello, int rreplen, unsigned int ifindex)
 {
@@ -232,10 +232,10 @@
 	ext = AODV_EXT_NEXT(ext);
     }
 
-#ifdef DEBUG_HELLO
+/* #ifdef DEBUG_HELLO */
     DEBUG(LOG_DEBUG, 0, "rcvd HELLO from %s, seqno %lu",
 	  ip_to_str(hello_dst), hello_seqno);
-#endif
+/* #endif */
     /* This neighbor should only be valid after receiving 3
        consecutive hello messages... */
     if (receive_n_hellos)
@@ -289,6 +289,71 @@
     return;
 }
 
+/* Process a broadcast message */
+void NS_CLASS bcast_process(u_int32_t addr,
+    int ifindex)
+{
+    u_int32_t hello_interval = HELLO_INTERVAL;
+    u_int32_t timeout;
+    u_int8_t state, flags = 0;
+    rt_table_t *rt;
+    struct timeval now;
+
+    gettimeofday(&now, NULL);
+
+    DEBUG(LOG_DEBUG, 0, "rcvd BCAST from %s",
+	  ip_to_str(addr));
+
+    /* This neighbor should only be valid after receiving 3
+       consecutive hello messages... */
+    if (receive_n_hellos)
+	state = INVALID;
+    else
+	state = VALID;
+
+    timeout = ALLOWED_HELLO_LOSS * hello_interval + ROUTE_TIMEOUT_SLACK;
+
+    if ((rt = rt_table_find(addr)) == NULL) {
+	/* No active or expired route in the routing table. So we add a
+	   new entry... */
+	
+        /* seqno == 0 because we have no idea... */
+	rt = rt_table_insert(addr, addr, 1, 0, timeout,
+				 state, flags, ifindex);
+	
+	if (flags & RT_UNIDIR)
+	    DEBUG(LOG_INFO, 0, "%s new NEIGHBOR, link UNI-DIR",
+	      ip_to_str(rt->dest_addr));
+	else
+	    DEBUG(LOG_INFO, 0, "%s new NEIGHBOR!", ip_to_str(rt->dest_addr));
+
+	rt->hello_cnt = 1;
+    } else {
+
+	if ((flags & RT_UNIDIR) && rt->state == VALID && rt->hcnt > 1) {
+	    goto hello_update;
+	}
+
+	if (receive_n_hellos && rt->hello_cnt < (receive_n_hellos - 1)) {
+	    if (timeval_diff(&now, &rt->last_hello_time) <
+		(long) (hello_interval + hello_interval / 2))
+		rt->hello_cnt++;
+	    else
+		rt->hello_cnt = 1;
+
+	    rt->last_hello_time = now;
+	    return;
+	}
+	rt_table_update(rt, addr, 1, rt->dest_seqno, timeout, VALID, 
+			flags);
+    }
+
+  hello_update:
+
+    hello_update_timeout(rt, ALLOWED_HELLO_LOSS * hello_interval);
+    rt->last_hello_time = now;
+    return;
+}
 
 #define HELLO_DELAY 50		/* The extra time we should allow an hello
 				   message to take (due to processing) before
diff -urNb aodv-uu-0.7.2/aodv_hello.h maodv-umd-0.7.2/aodv_hello.h
--- aodv-uu-0.7.2/aodv_hello.h	Thu May 22 19:11:34 2003
+++ maodv-umd-0.7.2/aodv_hello.h	Wed Jun 25 17:46:09 2003
@@ -38,8 +38,7 @@
 void hello_stop();
 void hello_send(void *arg);
 void hello_process(RREP * hello, int rreplen, unsigned int ifindex);
-void hello_process_non_hello(AODV_msg * aodv_msg, u_int32_t source,
-			     unsigned int ifindex);
+void NS_CLASS bcast_process(u_int32_t addr, int ifindex);
 NS_INLINE void hello_update_timeout(rt_table_t * rt, long time);
 
 #ifdef NS_PORT
diff -urNb aodv-uu-0.7.2/aodv_neighbor.c maodv-umd-0.7.2/aodv_neighbor.c
--- aodv-uu-0.7.2/aodv_neighbor.c	Tue May 27 12:32:58 2003
+++ maodv-umd-0.7.2/aodv_neighbor.c	Wed Jun 25 17:46:09 2003
@@ -43,6 +43,7 @@
     rt_table_t *rt = NULL;
     u_int32_t seqno = 0;
     int flags = 0;
+    struct timeval now;
 
     /* According to the draft, the seqno should always be set to
      * invalid when adding neighbors... */
@@ -69,6 +70,12 @@
 	rt_table_update(rt, source, 1, seqno, ACTIVE_ROUTE_TIMEOUT,
 			VALID, flags);
     }
+
+    gettimeofday(&now, NULL);
+    hello_update_timeout(rt, ALLOWED_HELLO_LOSS * HELLO_INTERVAL);
+    rt->last_hello_time = now;
+
+    DEBUG( LOG_DEBUG, 0, "Updated bcast/HELLO timer for %s", ip_to_str( source ) );
 
     if (!llfeedback) 
 	hello_update_timeout(rt, ALLOWED_HELLO_LOSS * HELLO_INTERVAL);
diff -urNb aodv-uu-0.7.2/aodv_rrep.c maodv-umd-0.7.2/aodv_rrep.c
--- aodv-uu-0.7.2/aodv_rrep.c	Tue May 27 12:32:58 2003
+++ maodv-umd-0.7.2/aodv_rrep.c	Wed Jun 25 17:46:09 2003
@@ -38,6 +38,13 @@
 
 extern int unidir_hack, optimized_hellos, llfeedback;
 
+#ifdef MAODV
+#include "maodv_rrep.h"
+#include "maodv_ext.h"
+#include "maodv_mact.h"
+#include "seek_list.h"
+#endif
+
 #endif
 
 RREP *NS_CLASS rrep_create(u_int8_t flags,
@@ -46,9 +53,14 @@
 			   u_int32_t dest_addr,
 			   u_int32_t dest_seqno,
 			   u_int32_t orig_addr, 
-			   u_int32_t life)
+			   u_int32_t life,
+                           u_int32_t grp_addr )
 {
     RREP *rrep;
+#ifdef MAODV
+    int size = RREP_SIZE;
+    GRP_MERGE_EXT * gme;
+#endif
 
     rrep = (RREP *) aodv_socket_new_msg();
     rrep->type = AODV_RREP;
@@ -66,6 +78,19 @@
     if (flags & RREP_ACK)
 	rrep->a = 1;
 
+#ifdef MAODV
+    if ( rrep->r ) {
+        /* add group merge extension */
+        gme = (GRP_MERGE_EXT *) ((char *)rrep + size);
+        gme->type = GME_TYPE;
+        gme->length = GME_LENGTH;
+        gme->res = 0;
+        gme->grp_addr = htonl(grp_addr);
+
+        size += GME_LENGTH + 2;    /* length + "header" */
+    }
+#endif /* MAODV */
+
     /* Don't print information about hello messages... */
 #ifdef DEBUG_OUTPUT
     if (dest_addr != orig_addr) {
@@ -107,13 +132,15 @@
     timer_remove(&rt->ack_timer);
 }
 
-void NS_CLASS rrep_send(rt_table_t * rev_rt, rt_table_t * fwd_rt)
+void NS_CLASS rrep_send(rt_table_t * rev_rt, rt_table_t * fwd_rt, 
+    u_int16_t flags, u_int32_t grp_addr )
 {
     RREP *rrep;
-    u_int8_t rrep_flags = 0;
+    u_int8_t rrep_flags = flags;
     u_int32_t seqno, dest, lifetime;
     int hcnt;
     struct timeval now;
+    int size = RREP_SIZE;
 
     if (!rev_rt) {
 	DEBUG(LOG_WARNING, 0, "Can't send RREP, rev_rt = NULL!");
@@ -165,9 +192,16 @@
 	  ip_to_str(dest));
 
     rrep = rrep_create(rrep_flags, 0, hcnt, dest, seqno, rev_rt->dest_addr,
-		       lifetime);
+		       lifetime, grp_addr );
+
+#ifdef MAODV
+    if ( rrep_flags & RREP_REPAIR ) {
+        DEBUG( LOG_DEBUG, 0, "RREP_GRP_MERGE_EXT set." );
+        size += GRP_MERGE_EXT_SIZE;
+    }
+#endif /* MAODV */
 
-    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, RREP_SIZE, MAXTTL,
+    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, size, MAXTTL,
 		     &DEV_IFINDEX(rev_rt->ifindex));
 
     /* Update precursor lists */
@@ -181,7 +215,7 @@
 }
 
 void NS_CLASS rrep_forward(RREP * rrep, rt_table_t * rev_rt,
-			   rt_table_t * fwd_rt, int ttl)
+			   rt_table_t * fwd_rt, int ttl, int size )
 {
     /* Sanity checks... */
     if (!fwd_rt || !rev_rt) {
@@ -220,10 +254,10 @@
 	}
     }
 
-    rrep = (RREP *) aodv_socket_queue_msg((AODV_msg *) rrep, RREP_SIZE);
+    rrep = (RREP *) aodv_socket_queue_msg((AODV_msg *) rrep, size);
     rrep->hcnt = fwd_rt->hcnt;	/* Update the hopcount */
 
-    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, RREP_SIZE, ttl,
+    aodv_socket_send((AODV_msg *) rrep, rev_rt->next_hop, size, ttl,
 		     &DEV_IFINDEX(rev_rt->ifindex));
 
     precursor_add(fwd_rt, rev_rt->next_hop);
@@ -239,6 +273,16 @@
     u_int32_t rrep_dest, rrep_orig, rrep_lifetime, rrep_seqno, rrep_new_hcnt;
     u_int8_t pre_repair_hcnt = 0, pre_repair_flags = 0;
     rt_table_t *fwd_rt, *rev_rt;
+    int size = rreplen;
+
+    AODV_ext * ext;
+
+#ifdef MAODV
+    GRP_MERGE_EXT * gmg_ext = NULL;
+    u_int32_t grp_addr;
+
+    grp_addr = 0;
+#endif
 
     /* Convert to correct byte order on affeected fields: */
     rrep_dest = ntohl(rrep->dest_addr);
@@ -265,6 +309,47 @@
     log_pkt_fields((AODV_msg *) rrep);
 #endif
     
+    ext = (AODV_ext *) ((char *) rrep + RREP_SIZE);
+
+    while( rreplen > (int) RREP_SIZE ) {
+        switch(ext->type) {
+#ifdef MAODV
+        case RREP_GRP_MERGE_EXT:
+            DEBUG(LOG_INFO, 0, "RREP includes group merge extension." );
+            gmg_ext = (GRP_MERGE_EXT *) ext;
+            if ( gmg_ext->length != GME_LENGTH ) {
+                DEBUG(LOG_DEBUG, 0, "Wrong length[%d] for gmg_ext.", 
+                    gmg_ext->length );
+                gmg_ext = NULL;
+            } else {
+                grp_addr = ntohl(gmg_ext->grp_addr);
+            }
+            break;
+#endif
+        default:
+            log(LOG_WARNING, 0, __FUNCTION__, "Unknown extension type %d",
+                ext->type);
+            break;
+        }
+        rreplen -= AODV_EXT_SIZE(ext);
+        ext = AODV_EXT_NEXT(ext);
+    }
+
+#ifdef MAODV
+    if ( IN_MULTICAST( rrep_dest ) ) {
+        DEBUG(LOG_DEBUG, 0, "MAODV rrep process." );
+        maodv_rrep_process( rrep, rreplen, ip_src, ip_dst, ip_ttl, 
+            ifindex, size);
+
+#ifndef AODVUU_LL_FEEDBACK
+        if (optimized_hellos)
+            hello_start();
+#endif
+
+        return;
+    }
+#endif
+
     /* ---------- CHECK IF WE SHOULD MAKE A FORWARD ROUTE ------------ */
     
     fwd_rt = rt_table_find(rrep_dest);
@@ -288,8 +373,13 @@
 	    DEBUG(LOG_DEBUG, 0, "Dropping RREP, fwd_rt->hcnt=%d fwd_rt->seqno=%ld",
 		  fwd_rt->hcnt, fwd_rt->dest_seqno);
 	}
+
+        if ( rrep->r ) {
+            DEBUG(LOG_DEBUG, 0, "Special RREP for group merge. Accepting despite an existing route." );
+        } else {
 	return;
     }
+    }
     
     
     /* If the RREP_ACK flag is set we must send a RREP
@@ -327,11 +417,102 @@
 				     RERR_CALC_SIZE(rerr), 1,
 				     &DEV_IFINDEX(fwd_rt->ifindex));
 	    }
+	} else {
+#ifdef MAODV
+            mrt_table_t *mrt;
+
+            if ( (gmg_ext != NULL) && 
+                 (mrt = mrt_table_find(grp_addr)) && 
+                 rrep->r ) {
+                mrt_nexthop_t *upstream;
+                
+                DEBUG(LOG_DEBUG, 0, "in gmg_ext processing section");
+                DEBUG(LOG_DEBUG, 0, "grp_addr: %s", ip_to_str(grp_addr));
+
+                /* make ip_src upstream */
+                upstream=mrt_table_get_activated_upstream(mrt);
+                if(upstream!=NULL){
+                    mrt_nexthop_deactivate(mrt, upstream->addr);
+                }
+
+                upstream=mrt_nexthop_find(mrt, ip_src);
+                if(upstream==NULL){
+                    upstream=mrt_nexthop_add(mrt, ip_src, MRT_UPSTREAM, 0);
+                }
+
+                if(upstream->activated){
+                    mrt_nexthop_deactivate(mrt, upstream->addr);
+                }
+                upstream->direction=MRT_UPSTREAM;
+
+                mrt_nexthop_activate(mrt, upstream->addr);
+                
+                /* send mact */
+                mact_send(MACT_JOIN, 1, grp_addr, ip_src, 1);
+
+                /* route is repaired */
+                mrt->in_repair=0;
+                
+                /* stop being leader */
+                mrt->am_leader = 0;
+
+                DEBUG( LOG_DEBUG, 0, "Giving up leadership to other leader." );
+                DEBUG( LOG_DEBUG, 0, "grp_addr: %s", ip_to_str(grp_addr) );
+
+                seek_list_remove_mcast(rrep_dest, grp_addr);
+            }
+#endif /* MAODV */
 	}
     } else {
 	/* --- Here we FORWARD the RREP on the REVERSE route --- */
 	if (rev_rt && rev_rt->state == VALID) {
-	    rrep_forward(rrep, rev_rt, fwd_rt, --ip_ttl);
+#ifdef MAODV
+            if ( rrep->r ) {
+                /* make old activated upstream a downstream? or let mact? */
+                mrt_table_t *mrt;
+
+                DEBUG(LOG_DEBUG, 0, "grp_addr: %s", ip_to_str(grp_addr));
+
+                if ( (gmg_ext != NULL) && 
+                     (mrt = mrt_table_find(grp_addr)) && 
+                     rrep->r ) {
+                    mrt_nexthop_t *upstream;
+
+                    DEBUG(LOG_DEBUG, 0, "in gmg_ext processing section");
+                    DEBUG(LOG_DEBUG, 0, "grp_addr: %s", ip_to_str(grp_addr));
+
+                    /* make ip_src upstream */
+                    upstream=mrt_table_get_activated_upstream(mrt);
+                    if(upstream!=NULL){
+                        mrt_nexthop_deactivate(mrt, upstream->addr);
+                    }
+
+                    upstream=mrt_nexthop_find(mrt, ip_src);
+                    if(upstream==NULL){
+                        upstream=mrt_nexthop_add(mrt, ip_src, 
+                            MRT_UPSTREAM, 0);
+                    }
+
+                    if(upstream->activated){
+                        mrt_nexthop_deactivate(mrt, upstream->addr);
+                    }
+                    upstream->direction=MRT_UPSTREAM;
+
+                    mrt_table_start_routing(mrt);
+
+                    mrt_nexthop_activate(mrt, upstream->addr);
+
+                    /* send mact */
+                    mact_send(MACT_JOIN, 1, grp_addr, ip_src, 1);
+                
+                    /* update GL information */
+                    /* GRPH->u */
+                }
+            }
+            rrep_forward(rrep, rev_rt, fwd_rt, --ip_ttl, size);
+#else  /* MAODV */
+	    rrep_forward(rrep, rev_rt, fwd_rt, --ip_ttl, size);
+#endif /* MAODV */
 	} else {
 	    DEBUG(LOG_DEBUG, 0, "Could not forward RREP - NO ROUTE!!!");
 	}
diff -urNb aodv-uu-0.7.2/aodv_rrep.h maodv-umd-0.7.2/aodv_rrep.h
--- aodv-uu-0.7.2/aodv_rrep.h	Thu May 22 19:11:35 2003
+++ maodv-umd-0.7.2/aodv_rrep.h	Wed Jun 25 17:46:09 2003
@@ -72,12 +72,14 @@
 		  u_int8_t prefix,
 		  u_int8_t hcnt,
 		  u_int32_t dest_addr,
-		  u_int32_t dest_seqno, u_int32_t orig_addr, u_int32_t life);
+		  u_int32_t dest_seqno, u_int32_t orig_addr, u_int32_t life,
+                  u_int32_t grp_addr );
 
 RREP_ack *rrep_ack_create();
-void rrep_send(rt_table_t * rev_rt, rt_table_t * fwd_rt);
+void rrep_send(rt_table_t * rev_rt, rt_table_t * fwd_rt, u_int16_t flags, 
+    u_int32_t grp_addr );
 void rrep_forward(RREP * rrep, rt_table_t * rev_rt, rt_table_t * fwd_rt,
-		  int ttl);
+		  int ttl, int size );
 void rrep_process(RREP * rrep, int rreplen, u_int32_t ip_src, u_int32_t ip_dst,
 		  int ip_ttl, unsigned int ifindex);
 void rrep_ack_process(RREP_ack * rrep_ack, int rreplen, u_int32_t ip_src,
